<?xml version="1.0" encoding="UTF-8"?>
<build-type xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" uuid="a0f421a1-510f-45ef-aada-7c7992561cad" paused="true" xsi:noNamespaceSchemaLocation="https://www.jetbrains.com/teamcity/schemas/2020.1/project-config.xsd">
  <name>PHPUnit - MSSQL</name>
  <description />
  <settings>
    <options>
      <option name="artifactRules" value="test/artifacts/**/*" />
    </options>
    <disabled-settings>
      <setting-ref ref="RUNNER_14" />
    </disabled-settings>
    <parameters />
    <build-runners>
      <runner id="RUNNER_4" name="Build PHP Image" type="DockerCommand">
        <parameters>
          <param name="command.args" value="--pull" />
          <param name="docker.command.type" value="build" />
          <param name="docker.image.namesAndTags" value="test:build" />
          <param name="docker.push.remove.image" value="true" />
          <param name="dockerImage.platform" value="linux" />
          <param name="dockerfile.path" value="build/Dockerfile" />
          <param name="dockerfile.source" value="PATH" />
          <param name="teamcity.step.mode" value="default" />
        </parameters>
      </runner>
      <runner id="RUNNER_12" name="Pre Docker Compose" type="simpleRunner">
        <parameters>
          <param name="script.content"><![CDATA[if [ -d "artifacts" ]; then rm -Rf artifacts; fi
mkdir artifacts
if [ -d "db_dir" ]; then rm -Rf db_dir; fi]]></param>
          <param name="teamcity.build.workingDir" value="test" />
          <param name="teamcity.step.mode" value="default" />
          <param name="use.custom.script" value="true" />
        </parameters>
      </runner>
      <runner id="RUNNER_22" name="Setup Loopback" type="simpleRunner">
        <parameters>
          <param name="script.content"><![CDATA[# Create a 1GB disk image inside of the tmpfs.
dd if=/dev/zero of=disk.img bs=1M count=1024
mkdir -p /data

# Create a new loopback device from the disk image.
losetup /dev/loop72 disk.img

# Format as ext4.
mkfs.ext4 /dev/loop72

# Mount the loopback image as /data
mount /dev/loop72 /data]]></param>
          <param name="teamcity.build.workingDir" value="test" />
          <param name="teamcity.step.mode" value="default" />
          <param name="use.custom.script" value="true" />
        </parameters>
      </runner>
      <runner id="RUNNER_5" name="Start dependencies" type="DockerCompose">
        <parameters>
          <param name="dockerCompose.file" value="test/moodle/phpunit/docker-compose-mssql.yml" />
          <param name="teamcity.step.mode" value="default" />
        </parameters>
      </runner>
      <runner id="RUNNER_18" name="Init PHPUnit" type="simpleRunner">
        <parameters>
          <param name="script.content"><![CDATA[docker ps
docker-compose logs
docker exec -w /opt/mssql-tools/bin phpunit_mssql_1 /opt/mssql-tools/bin/sqlcmd -S localhost -U sa -P "P@ssw0rd" -Q "CREATE DATABASE moodle_db COLLATE Latin1_General_CI_AI;"
docker exec -w /opt/mssql-tools/bin phpunit_mssql_1 /opt/mssql-tools/bin/sqlcmd -S localhost -U sa -P "P@ssw0rd" -Q "ALTER DATABASE moodle_db SET READ_COMMITTED_SNAPSHOT ON;"
docker exec -w /opt/mssql-tools/bin phpunit_mssql_1 /opt/mssql-tools/bin/sqlcmd -S localhost -U sa -P "P@ssw0rd" -Q "ALTER DATABASE moodle_db SET ANSI_NULLS ON;"
docker exec -w /opt/mssql-tools/bin phpunit_mssql_1 /opt/mssql-tools/bin/sqlcmd -S localhost -U sa -P "P@ssw0rd" -Q "ALTER DATABASE moodle_db SET QUOTED_IDENTIFIER ON;"

docker exec -w /var/www/html/moodle phpunit_webserver_1 rm config.php
docker exec -w /var/www/html/moodle phpunit_webserver_1 mv config-ci-mssql.php config.php

docker exec -w /var/www/html/moodle phpunit_webserver_1 php composer.phar install
docker exec -w /var/www/html/moodle phpunit_webserver_1 php admin/tool/phpunit/cli/init.php]]></param>
          <param name="teamcity.build.workingDir" value="test" />
          <param name="teamcity.step.mode" value="default" />
          <param name="use.custom.script" value="true" />
        </parameters>
      </runner>
      <runner id="RUNNER_8" name="Perform PHPUnit Tests (Short)" type="simpleRunner">
        <parameters>
          <param name="script.content"><![CDATA[docker exec -w /var/www/html/moodle phpunit_webserver_1 vendor/bin/phpunit --testsuite core_rss_testsuite --log-junit /artifacts/junit.xml --coverage-html /artifacts/coverage/
ls artifacts]]></param>
          <param name="teamcity.build.workingDir" value="test" />
          <param name="teamcity.step.mode" value="default" />
          <param name="use.custom.script" value="true" />
        </parameters>
      </runner>
      <runner id="RUNNER_14" name="Perform PHPUnit Tests (Full)" type="simpleRunner">
        <parameters>
          <param name="script.content"><![CDATA[#docker exec -w /var/www/html/moodle phpunit_webserver_1 vendor/bin/phpunit --testdox --log-junit /artifacts/junit.xml --coverage-html /artifacts/coverage/
docker exec -w /var/www/html/moodle phpunit_webserver_1 vendor/bin/phpunit --log-junit /artifacts/junit.xml --coverage-html /artifacts/coverage/
ls artifacts]]></param>
          <param name="teamcity.build.workingDir" value="test" />
          <param name="teamcity.step.mode" value="default" />
          <param name="use.custom.script" value="true" />
        </parameters>
      </runner>
      <runner id="RUNNER_23" name="Delete Loopback" type="simpleRunner">
        <parameters>
          <param name="script.content"><![CDATA[# Unmount loopback
umount /data
losetup -d /dev/loop72

# Delete ramdisk image
rm disk.img
rm -r /data]]></param>
          <param name="teamcity.build.workingDir" value="test" />
          <param name="teamcity.step.mode" value="execute_always" />
          <param name="use.custom.script" value="true" />
        </parameters>
      </runner>
    </build-runners>
    <vcs-settings>
      <vcs-entry-ref root-id="DockerfiedMoodle_GitlabDockerfieldMoodle" />
    </vcs-settings>
    <requirements />
    <build-triggers>
      <build-trigger id="vcsTrigger" type="vcsTrigger">
        <parameters>
          <param name="branchFilter" value="+:*" />
          <param name="enableQueueOptimization" value="true" />
          <param name="quietPeriodMode" value="DO_NOT_USE" />
        </parameters>
      </build-trigger>
    </build-triggers>
    <build-extensions>
      <extension id="BUILD_EXT_4" type="xml-report-plugin">
        <parameters>
          <param name="xmlReportParsing.reportDirs" value="test/artifacts/*.xml" />
          <param name="xmlReportParsing.reportType" value="junit" />
        </parameters>
      </extension>
      <extension id="KEEP_RULE_3" type="keepRules">
        <parameters>
          <param name="keepData.1.type" value="everything" />
          <param name="limit.type" value="all" />
          <param name="partitions.1.type" value="perBranch" />
          <param name="preserveArtifacts" value="true" />
          <param name="ruleDisabled" value="false" />
        </parameters>
      </extension>
    </build-extensions>
    <cleanup />
  </settings>
</build-type>

